/**********************************************************************
 * Copyright (c) 2003, 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: XMLmethodReturnLoader.java,v 1.3 2006-02-08 19:56:55 slavescu Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 * 
 * $Id: XMLmethodReturnLoader.java,v 1.3 2006-02-08 19:56:55 slavescu Exp $
 **********************************************************************/
package org.eclipse.hyades.loaders.trace;

import org.eclipse.hyades.loaders.trace.TraceUtils.InvocationInfo;
import org.eclipse.hyades.models.trace.TRCCallerCalleeInvocationInfo;


/**
 * @author slavescu
 *
 */
public class XMLmethodReturnLoader extends XMLmethodExitLoader {

    protected void processEF(int step) {
//        super.processEF(step);

        _fullInvocation = ((InvocationInfo) _cs.peek()).getMethodInvocation();

        if (_fullInvocation != null) {
            theThread = _fullInvocation.getThread();
            if(_fullInvocation instanceof TRCCallerCalleeInvocationInfo)
            	((TRCCallerCalleeInvocationInfo)_fullInvocation).setReturnTime(createDeltaTime());
            else {
            	_fullInvocation.setOrigExitTime(time);
                _fullInvocation.setExitTime(createDeltaTime());
}            if(_fullInvocation instanceof TRCCallerCalleeInvocationInfo)
            	((TRCCallerCalleeInvocationInfo)_fullInvocation).setCallOverhead(overhead);
            else
            	_fullInvocation.setOverhead(overhead);
            addInputOutputValues();
            
    		synchronized (_REMOTE_INVOCATION_RESOLUTION_LOCK) {
    			updateForwardInvokes(_fullInvocation);
    		}

//            updateStatisticalInfo();
            _invocationPool.release((InvocationInfo) _cs.pop());
        } else {
            // ignore method exit if there is no method entry
        }
    }

    protected void processES(int step) {
//        super.processES(step);

        //		theThread = getThreadByIdRef(theProcess);
        //		theMethod = fullInvocation.getMethod();
        //		theObject = fullInvocation.getOwningObject();
        //		theClass = theMethod.getDefiningClass();
//        updateStatisticalInfoOnly();
    }
}
