/**********************************************************************
 * Copyright (c) 2011 IBM Corporation 
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: 
 **********************************************************************/

package org.eclipse.hyades.models.hierarchy;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TRCTI Profiler Collection Mode</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCTIProfilerCollectionMode()
 * @model
 * @generated
 */
public enum TRCTIProfilerCollectionMode implements Enumerator {
	/**
	 * The '<em><b>UNKNOWN</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN_VALUE
	 * @generated
	 * @ordered
	 */
	UNKNOWN(0, "UNKNOWN", "UNKNOWN"), /**
	 * The '<em><b>HEAP NO ALLOC SITES</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_NO_ALLOC_SITES_VALUE
	 * @generated
	 * @ordered
	 */
	HEAP_NO_ALLOC_SITES(1, "HEAP_NO_ALLOC_SITES", "HEAP_NO_ALLOC_SITES"),

	/**
	 * The '<em><b>HEAP ALLOC SITES</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_ALLOC_SITES_VALUE
	 * @generated
	 * @ordered
	 */
	HEAP_ALLOC_SITES(2, "HEAP_ALLOC_SITES", "HEAP_ALLOC_SITES"),

	/**
	 * The '<em><b>EXEC STATS</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXEC_STATS_VALUE
	 * @generated
	 * @ordered
	 */
	EXEC_STATS(3, "EXEC_STATS", "EXEC_STATS"),

	/**
	 * The '<em><b>EXEC FLOW</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXEC_FLOW_VALUE
	 * @generated
	 * @ordered
	 */
	EXEC_FLOW(4, "EXEC_FLOW", "EXEC_FLOW"),

	/**
	 * The '<em><b>THREAD NO CONTENTION</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #THREAD_NO_CONTENTION_VALUE
	 * @generated
	 * @ordered
	 */
	THREAD_NO_CONTENTION(5, "THREAD_NO_CONTENTION", "THREAD_NO_CONTENTION"),

	/**
	 * The '<em><b>THREAD CONTENTION</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #THREAD_CONTENTION_VALUE
	 * @generated
	 * @ordered
	 */
	THREAD_CONTENTION(6, "THREAD_CONTENTION", "THREAD_CONTENTION");

	/**
	 * The '<em><b>UNKNOWN</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>UNKNOWN</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int UNKNOWN_VALUE = 0;

	/**
	 * The '<em><b>HEAP NO ALLOC SITES</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP NO ALLOC SITES</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_NO_ALLOC_SITES
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_NO_ALLOC_SITES_VALUE = 1;

	/**
	 * The '<em><b>HEAP ALLOC SITES</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP ALLOC SITES</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_ALLOC_SITES
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_ALLOC_SITES_VALUE = 2;

	/**
	 * The '<em><b>EXEC STATS</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EXEC STATS</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXEC_STATS
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int EXEC_STATS_VALUE = 3;

	/**
	 * The '<em><b>EXEC FLOW</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EXEC FLOW</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXEC_FLOW
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int EXEC_FLOW_VALUE = 4;

	/**
	 * The '<em><b>THREAD NO CONTENTION</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>THREAD NO CONTENTION</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #THREAD_NO_CONTENTION
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int THREAD_NO_CONTENTION_VALUE = 5;

	/**
	 * The '<em><b>THREAD CONTENTION</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>THREAD CONTENTION</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #THREAD_CONTENTION
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int THREAD_CONTENTION_VALUE = 6;

	/**
	 * An array of all the '<em><b>TRCTI Profiler Collection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TRCTIProfilerCollectionMode[] VALUES_ARRAY =
		new TRCTIProfilerCollectionMode[] {
			UNKNOWN,
			HEAP_NO_ALLOC_SITES,
			HEAP_ALLOC_SITES,
			EXEC_STATS,
			EXEC_FLOW,
			THREAD_NO_CONTENTION,
			THREAD_CONTENTION,
		};

	/**
	 * A public read-only list of all the '<em><b>TRCTI Profiler Collection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<TRCTIProfilerCollectionMode> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TRCTI Profiler Collection Mode</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCTIProfilerCollectionMode get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TRCTIProfilerCollectionMode result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TRCTI Profiler Collection Mode</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCTIProfilerCollectionMode getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TRCTIProfilerCollectionMode result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TRCTI Profiler Collection Mode</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCTIProfilerCollectionMode get(int value) {
		switch (value) {
			case UNKNOWN_VALUE: return UNKNOWN;
			case HEAP_NO_ALLOC_SITES_VALUE: return HEAP_NO_ALLOC_SITES;
			case HEAP_ALLOC_SITES_VALUE: return HEAP_ALLOC_SITES;
			case EXEC_STATS_VALUE: return EXEC_STATS;
			case EXEC_FLOW_VALUE: return EXEC_FLOW;
			case THREAD_NO_CONTENTION_VALUE: return THREAD_NO_CONTENTION;
			case THREAD_CONTENTION_VALUE: return THREAD_CONTENTION;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TRCTIProfilerCollectionMode(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //TRCTIProfilerCollectionMode
