/**********************************************************************
 * Copyright (c) 2007, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCObjectAllocationAnnotation.java,v 1.5 2009-05-05 15:49:16 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.hierarchy.TRCAnnotation;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Object Allocation Annotation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectAllocationAnnotation#getMethods <em>Methods</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectAllocationAnnotation#getClasses <em>Classes</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectAllocationAnnotation#getLineNumbers <em>Line Numbers</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectAllocationAnnotation#getCreateTimes <em>Create Times</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectAllocationAnnotation()
 * @model
 * @generated
 */
public interface TRCObjectAllocationAnnotation extends TRCAnnotation {
	/**
	 * Returns the value of the '<em><b>Methods</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.trace.TRCMethod}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Methods</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Methods</em>' reference list.
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectAllocationAnnotation_Methods()
	 * @model
	 * @generated
	 */
	EList<TRCMethod> getMethods();

	/**
	 * Returns the value of the '<em><b>Classes</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.trace.TRCClass}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Classes</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Classes</em>' reference list.
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectAllocationAnnotation_Classes()
	 * @model
	 * @generated
	 */
	EList<TRCClass> getClasses();

	/**
	 * Returns the value of the '<em><b>Line Numbers</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Integer}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Line Numbers</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Line Numbers</em>' attribute list.
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectAllocationAnnotation_LineNumbers()
	 * @model unique="false"
	 * @generated
	 */
	EList<Integer> getLineNumbers();

	/**
	 * Returns the value of the '<em><b>Create Times</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Double}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Create Times</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Create Times</em>' attribute list.
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectAllocationAnnotation_CreateTimes()
	 * @model unique="false"
	 * @generated
	 */
	EList<Double> getCreateTimes();

} // TRCObjectAllocationAnnotation
