/**********************************************************************
 * Copyright (c) 2011 IBM Corporation
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: 
 **********************************************************************/
package org.eclipse.hyades.models.trace.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.hyades.models.trace.TRCMemoryStatsManager;
import org.eclipse.hyades.models.trace.TracePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>TRC Memory Stats Manager</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCMemoryStatsManagerImpl#getNumFullMethInvocObjs <em>Num Full Meth Invoc Objs</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCMemoryStatsManagerImpl#getNumAggMethInvocObjs <em>Num Agg Meth Invoc Objs</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCMemoryStatsManagerImpl#getNumHeapObjs <em>Num Heap Objs</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TRCMemoryStatsManagerImpl extends EObjectImpl implements TRCMemoryStatsManager {
	/**
	 * The default value of the '{@link #getNumFullMethInvocObjs() <em>Num Full Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumFullMethInvocObjs()
	 * @generated
	 * @ordered
	 */
	protected static final long NUM_FULL_METH_INVOC_OBJS_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getNumFullMethInvocObjs() <em>Num Full Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumFullMethInvocObjs()
	 * @generated
	 * @ordered
	 */
	protected long numFullMethInvocObjs = NUM_FULL_METH_INVOC_OBJS_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumAggMethInvocObjs() <em>Num Agg Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumAggMethInvocObjs()
	 * @generated
	 * @ordered
	 */
	protected static final long NUM_AGG_METH_INVOC_OBJS_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getNumAggMethInvocObjs() <em>Num Agg Meth Invoc Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumAggMethInvocObjs()
	 * @generated
	 * @ordered
	 */
	protected long numAggMethInvocObjs = NUM_AGG_METH_INVOC_OBJS_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumHeapObjs() <em>Num Heap Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumHeapObjs()
	 * @generated
	 * @ordered
	 */
	protected static final long NUM_HEAP_OBJS_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getNumHeapObjs() <em>Num Heap Objs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumHeapObjs()
	 * @generated
	 * @ordered
	 */
	protected long numHeapObjs = NUM_HEAP_OBJS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TRCMemoryStatsManagerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TracePackage.Literals.TRC_MEMORY_STATS_MANAGER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getNumFullMethInvocObjs() {
		return numFullMethInvocObjs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumFullMethInvocObjs(long newNumFullMethInvocObjs) {
		long oldNumFullMethInvocObjs = numFullMethInvocObjs;
		numFullMethInvocObjs = newNumFullMethInvocObjs;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS, oldNumFullMethInvocObjs, numFullMethInvocObjs));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getNumAggMethInvocObjs() {
		return numAggMethInvocObjs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumAggMethInvocObjs(long newNumAggMethInvocObjs) {
		long oldNumAggMethInvocObjs = numAggMethInvocObjs;
		numAggMethInvocObjs = newNumAggMethInvocObjs;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS, oldNumAggMethInvocObjs, numAggMethInvocObjs));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getNumHeapObjs() {
		return numHeapObjs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumHeapObjs(long newNumHeapObjs) {
		long oldNumHeapObjs = numHeapObjs;
		numHeapObjs = newNumHeapObjs;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS, oldNumHeapObjs, numHeapObjs));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS:
				return getNumFullMethInvocObjs();
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS:
				return getNumAggMethInvocObjs();
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS:
				return getNumHeapObjs();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS:
				setNumFullMethInvocObjs((Long)newValue);
				return;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS:
				setNumAggMethInvocObjs((Long)newValue);
				return;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS:
				setNumHeapObjs((Long)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS:
				setNumFullMethInvocObjs(NUM_FULL_METH_INVOC_OBJS_EDEFAULT);
				return;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS:
				setNumAggMethInvocObjs(NUM_AGG_METH_INVOC_OBJS_EDEFAULT);
				return;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS:
				setNumHeapObjs(NUM_HEAP_OBJS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS:
				return numFullMethInvocObjs != NUM_FULL_METH_INVOC_OBJS_EDEFAULT;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS:
				return numAggMethInvocObjs != NUM_AGG_METH_INVOC_OBJS_EDEFAULT;
			case TracePackage.TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS:
				return numHeapObjs != NUM_HEAP_OBJS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (numFullMethInvocObjs: ");
		result.append(numFullMethInvocObjs);
		result.append(", numAggMethInvocObjs: ");
		result.append(numAggMethInvocObjs);
		result.append(", numHeapObjs: ");
		result.append(numHeapObjs);
		result.append(')');
		return result.toString();
	}

} //TRCMemoryStatsManagerImpl
