/**********************************************************************
 * Copyright (c) 2010, 2016 IBM Corporation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.trace.ui;

import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.hyades.trace.ui.internal.util.FilterSetElement;
import org.eclipse.ui.IWorkingSet;

public interface IProfilerFilterProcessorExtension {

	/** Provides the extension with the launch configuration and working sets, which contain
	 * the filter and filter settings to be processed. (Bug 323330) */
	public void processFilter(ILaunchConfigurationWorkingCopy conf, IWorkingSet[] workingSets);
	
	/** Provides the extension with the launch configuration and working sets, to display the 
	 * auto filter's content to the filterUI page*/
	public void displayAutoFilterCotent(ILaunchConfiguration conf,IWorkingSet[] workingSets, FilterSetElement FSE);

}
