/*****************************************************************************
 * Copyright (c) 2008, 2011 Intel Corporation and IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Intel Corporation - Initial API and implementation
 *
 * $Id: TIThreadAnalysisUI.java,v 1.1 2008-02-28 12:50:06 ialelekov Exp $
 *****************************************************************************/
package org.eclipse.tptp.platform.jvmti.client.internal.analysistypes;

import org.eclipse.hyades.trace.ui.internal.util.TraceMessages;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.tptp.platform.jvmti.client.internal.TIMessages;

public class TIThreadAnalysisUI {
    /* Contention analysis option */
    private Button contentionAnalysisBtn;
	private boolean _isAttachScenario;    

    public void createControl(Composite parent) {
    	
    	createLevelOfDetailGroup(parent);
    }

    private void createLevelOfDetailGroup(Composite parent) {
    	Group gr = createGroup(parent, TIMessages.EXEC_LEVEL_OF_DETAIL);

    	if(_isAttachScenario) {
    		createAttachWarning(gr);
    	}
    	
    	contentionAnalysisBtn = createButton(gr, TIMessages.EXEC_CONTENTION_ANALYSIS, SWT.CHECK);
    	
    	if(_isAttachScenario) {
    		contentionAnalysisBtn.setEnabled(!_isAttachScenario);
    	}
    }

    private Group createGroup(Composite parent, String name) {
    	Group grp = new Group(parent, SWT.NONE);
    	grp.setLayout(new GridLayout());
    	grp.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, true));
    	grp.setText(name);

    	return grp;
    }

    private Button createButton(Composite parent, String name, int style) {
    	Button button = new Button(parent, style);
    	button.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false));
    	button.setText(name);

    	return button;
    }

    public boolean getContentionAnalysis() {
    	return contentionAnalysisBtn != null && !contentionAnalysisBtn.isDisposed() && 
				contentionAnalysisBtn.getSelection();
    }

    public void setContentionAnalysis(boolean enabled) {
    	contentionAnalysisBtn.setSelection(enabled);
    }
    
	public void setIsAttachScenario(boolean b) {
		_isAttachScenario = b;
	}
    
	
	private void createAttachWarning(final Composite parent) {
    	Composite c = new Composite(parent, SWT.NONE);
    	c.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, true));
    	
    	final GridLayout layout = new GridLayout();
    	layout.numColumns = 1;
    	
    	c.setLayout(layout);
    	
    	final GridData gd = new GridData(SWT.DEFAULT);
    	
    	final Label l = new Label(c, SWT.WRAP);
    	l.setText(TraceMessages.ATTACH_SCENARIO_WARNING);
    	
    	l.setLayoutData(gd);
    	
    	
	}
	
    public boolean isContButtonDisposed() {
    	return contentionAnalysisBtn.isDisposed();
    }
}
