/**********************************************************************
 * Copyright (c) 2007, 2015 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.jvmti.client.internal.launcher;

import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.tptp.platform.jvmti.client.internal.launcher.TIDelegateHelper.JVMVersionDetector;
import org.eclipse.tptp.trace.ui.provisional.launcher.ICollectorFiltration;

/**
 * This filtration class is used to filter the JVMTI data collector if the
 * targeted host uses JRE 1.5 or older.
 *  
 * @author Ali Mehregani
 */
public class TICollectorFiltration implements ICollectorFiltration
{
	public boolean include(String id, ILaunchConfiguration configuration, Object context)
	{
		JVMVersionDetector jvmVersionDetector = new JVMVersionDetector(configuration);
		String version = jvmVersionDetector.retrieveVersionOutput();		
		return version == null || version.length() <= 0 || (version.indexOf("java version \"1.3.") == -1 && version.indexOf("java version \"1.4.") == -1 && version.indexOf("java version \"1.5.") == -1);	
	}
}
