/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGFeGaussianBlur.java,v 1.2 2005-06-10 17:47:09 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.generator;
/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGFeGaussianBlur.java,v 1.2 2005-06-10 17:47:09 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * <code>SVGFeGaussianBlur</code> is a implementation class for Scalable Vector Graphics (SVG) 
 * "feGaussianBlur" elements. 
 * 
 * $Revision: 1.2 $
 */
public class SVGFeGaussianBlur extends SVGFeGaussianBlurBase {

	private Element implementation;
	static final long serialVersionUID = -744762204509536143L;	
	/**
	 * Sole constructor.
	 */
	public SVGFeGaussianBlur() {
		super();
		setTagName("feGaussianBlur");
	}	
		
	/**
	 * Creates the Document Object Model (DOM) implementation of the SVG "feGaussianBlur" element
	 * 	
	 * @param Document the target SVG Document
	 * @param String the stdDeviation
	 * @param String the in
	 * @param String the result
	 * @return Element the implementation 
	 * @throws NullPointerException ???
	 */
	public Element doImplementation(Document svgDocument, String stdDeviation, String in, String result) throws NullPointerException {	
		setStdDeviation(stdDeviation);
		setIn(in);
		setResult(result);	
				
		try {
			implementation = super.doImplementation(svgDocument);			
		} catch (DOMException e) {}				
		
		return implementation;	
	}
				
	/**
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.generator.svg.SVGBase#getImplementation() 
	 */
	public Element getImplementation() {
		return implementation;
	}	

}
