/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ChartArea.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ChartArea.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;

import java.util.List;



/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chart Area</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#getBackgroundColor <em>Background Color</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#isBorder <em>Border</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface ChartArea {
	/**
	 * Returns the value of the '<em><b>Background Color</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Background Color</em>' attribute.
	 * @see #setBackgroundColor(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getChartArea_BackgroundColor()
	 * @model 
	 * @generated
	 */
	String getBackgroundColor();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#getBackgroundColor <em>Background Color</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Background Color</em>' attribute.
	 * @see #getBackgroundColor()
	 * @generated
	 */
	void setBackgroundColor(String value);

	/**
	 * Returns the value of the '<em><b>Border</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Border</em>' attribute.
	 * @see #isSetBorder()
	 * @see #unsetBorder()
	 * @see #setBorder(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getChartArea_Border()
	 * @model default="true" unsettable="true"
	 * @generated
	 */
	boolean isBorder();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#isBorder <em>Border</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Border</em>' attribute.
	 * @see #isSetBorder()
	 * @see #unsetBorder()
	 * @see #isBorder()
	 * @generated
	 */
	void setBorder(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#isBorder <em>Border</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetBorder()
	 * @see #isBorder()
	 * @see #setBorder(boolean)
	 * @generated
	 */
	void unsetBorder();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#isBorder <em>Border</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Border</em>' attribute is set.
	 * @see #unsetBorder()
	 * @see #isBorder()
	 * @see #setBorder(boolean)
	 * @generated
	 */
	boolean isSetBorder();
	/**
	 * Returns the value of the '<em><b>Accessibility</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Accessibility</em>' containment reference.
	 * @see #setAccessibility(Accessibility)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getChartArea_Accessibility()
	 * @model containment="true"
	 * @generated
	 */
	Accessibility getAccessibility();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.ChartArea#getAccessibility <em>Accessibility</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Accessibility</em>' containment reference.
	 * @see #getAccessibility()
	 * @generated
	 */
	void setAccessibility(Accessibility value);

	/**
	 * Returns the value of the '<em><b>Event Handler</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.tptp.platform.report.chart.svg.internal.input.EventHandler}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Handler</em>' containment reference list.
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getChartArea_EventHandler()
	 * @model type="org.eclipse.tptp.platform.report.chart.svg.internal.input.EventHandler" containment="true"
	 * @generated
	 */
	List getEventHandler();

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // ChartArea
