/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CustomFormatImpl.java,v 1.1 2005-03-30 08:26:39 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CustomFormatImpl.java,v 1.1 2005-03-30 08:26:39 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input.impl;

import org.eclipse.tptp.platform.report.chart.svg.internal.input.Chart;
import org.eclipse.tptp.platform.report.chart.svg.internal.input.CustomFormat;
import org.w3c.dom.Element;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Custom Format</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.impl.CustomFormatImpl#getFormatClass <em>Format Class</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CustomFormatImpl extends InputBase implements CustomFormat {
	/**
	 * The default value of the '{@link #getFormatClass() <em>Format Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormatClass()
	 * @generated
	 * @ordered
	 */
	protected static final String FORMAT_CLASS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFormatClass() <em>Format Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormatClass()
	 * @generated
	 * @ordered
	 */
	protected String formatClass = FORMAT_CLASS_EDEFAULT;


	/**
	 * The default value of the '{@link #getPattern() <em>Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPattern()
	 * @generated
	 * @ordered
	 */
	protected static final String PATTERN_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPattern() <em>Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPattern()
	 * @generated
	 * @ordered
	 */
	protected String pattern = PATTERN_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CustomFormatImpl()
	{
		super();
	}
	
	public CustomFormatImpl(Chart chart) {
		_chart = chart;
		if (_chart.getElement() != null) {
			_element = _chart.getElement().getOwnerDocument().createElement("customFormat");
		}
	}

	public CustomFormatImpl(Chart chart, Element element) {
		_chart = chart;
		_element = element;
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFormatClass()
	{
		if (formatClass == FORMAT_CLASS_EDEFAULT) {
			if (_element != null && _element.hasAttribute("formatClass")) {
				formatClass = _element.getAttribute("formatClass");
			}
		}
		return formatClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFormatClass(String newFormatClass)
	{
		formatClass = newFormatClass;
		
		if (_element != null) {
			_element.setAttribute("formatClass", newFormatClass);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (formatClass: ");
		result.append(formatClass);
		result.append(')');
		return result.toString();
	}
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPattern() {
		if (pattern == PATTERN_EDEFAULT) {
			if (_element != null && _element.hasAttribute("pattern")) {
				pattern = _element.getAttribute("pattern");
			}
		}
		return pattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPattern(String newPattern) {
		pattern = newPattern;
		
		if (_element != null) {
			_element.setAttribute("pattern", newPattern);
		}
	}
} //CustomFormatImpl
