/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IDWallpaper.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 8 dc. 2003
 *
 */
package org.eclipse.tptp.platform.report.core.internal;

/**
 * Provides an interface for wallpaper definition.
 * Wallpaper is a property of IDStyle, drivers can use it to illuminate sober documents.
 * JScrib profites an implementation of this interface : DWallpaper.
 * 
 * @see DWallpaper
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IDWallpaper extends IDStringSerializable
{
  /** 
   * Returns the name of the Wall Pager 
   */
  public String getName();
  
  /**
   * Returns the effect applied on the wall paper 
   */
  public int    getEffect();
}
