/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IFontMetrics.java,v 1.2 2008-05-23 14:11:51 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.igc.internal;

/**
 * Interface to retrieve IGC's font metrics.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IFontMetrics 
{
  /** Returns the ascent of the font (in pixels). */
 public int getAscent();
 /**  Returns the average character width, measured in pixels, of the font described by the receiver. */         
//TODO:usefull?: int getAverageCharWidth(); 
     
 /** Returns the descent of the font (in pixels). */
 public int getDescent(); 
            
 /** Returns the height of the font (in pixels). */
 int getHeight();
            
 /** Returns the leading of the font (in pixels). */
 int getLeading();

}
