/************************************************************************
 * Copyright (c) 2006 - 2007 Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Intel Corporation - Initial API and implementation
 *    Viacheslav Rybalov, Intel - Initial API and implementation
 *
 * $Id: ThreadEndEvent.h,v 1.2 2007-03-23 14:04:45 vrybalov Exp $ 
 ************************************************************************/

#ifndef _THREAD_END_EVENT_H_
#define _THREAD_END_EVENT_H_

#include "MpiAPI.h"
#include "ProfEnv.h"
//#include "Tickets.h"
#include "log.h"

namespace Martini { namespace HeapProf {

    // CThreadEndEvent - represents thread end event 
	class CThreadEndEvent : public MPI::IThreadEndEventObserver
    {
    public:
        // Constructor
        CThreadEndEvent();
        // Destructor
        ~CThreadEndEvent();
        // Initializes internal data and registers thread end event
        TResult Init(BaseProf::CProfEnv* profEnv);
        // Inherited methods
        void HandleEvent(MPI::SThreadEventData &data);

    private:
        // profiler environment
        BaseProf::CProfEnv* m_pProfEnv;
    };

} /*namespace Martini*/ } /*namespace HeapProf*/

#endif // _THREAD_END_EVENT_H_

