/*******************************************************************************
 * Copyright (c) 2011 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/ 
package org.eclipse.tptp.platform.execution.client.core.internal.commands;

import org.eclipse.tptp.platform.execution.util.internal.CommandElement;
import org.eclipse.tptp.platform.execution.util.internal.Constants;
import org.eclipse.tptp.platform.execution.util.internal.TPTPMessageUtil;
import org.eclipse.tptp.platform.execution.util.internal.TPTPString;

public class GetPropertyListCommand extends CommandElement {

	private String name;
	private String type;
	
	public GetPropertyListCommand( String name, String type ) {
		
		this.name = name;
		this.type = type;
		
	}
	
	public String buildCommand() {
		return "<getPropertyList iid=\"" + Constants.AGNT_MGR_IID + "\">"
			+ 	"<name>" + this.name + "</name>"
			+ 	"<type>" + this.type + "</type>"
			+ "</getPropertyList>";
	}

	@Override
	public int getSize() {
		return buildCommand().length();
	}

	@Override
	public int readFromBuffer(byte[] buffer, int offset) {
		// This command is never read from a buffer
		return 0;
	}

	@Override
	public int writeToBuffer(byte[] buffer, int offset) {
		int current=offset;
		current=TPTPMessageUtil.writeTPTPStringToBuffer(buffer, current, new TPTPString(this.buildCommand()));
		return current;		
	}

}
